package Class::Std::Utils;
use warnings;
use strict;
use Carp;
use Scalar::Util qw( refaddr );
sub import{my$caller=caller;
no strict qw( refs );
*{$caller.'::anon_scalar'}=\&anon_scalar;
*{$caller.'::ident'}=\&refaddr;
*{$caller.'::extract_initializers_from'}=\&extract_initializers_from;}sub anon_scalar{return\my$scalar;}use List::Util qw( first );
sub extract_initializers_from{my($arg_ref)=@_;
my$class_name=caller;
my$specific_inits_ref=first{defined$_}$arg_ref->{$class_name},{};
croak"$class_name initializer must be a nested hash"        if ref$specific_inits_ref ne 'HASH';
return(%{$arg_ref},%{$specific_inits_ref});}1;
__END__

