use 5.006;
use strict;
use warnings;
package Email::Simple;
use Carp ();
use Email::Simple::Creator;
use Email::Simple::Header;
our$VERSION='2.100';
our$GROUCHY=0;
sub __crlf_re{qr/\x0a\x0d|\x0d\x0a|\x0a|\x0d/;}sub new{my($class,$text,$arg)=@_;
$arg||={};
Carp::croak 'Unable to parse undefined message' if!defined$text;
my$text_ref=ref$text?$text:\$text;
my($pos,$mycrlf)=$class->_split_head_from_body($text_ref);
my$self=bless{mycrlf=>$mycrlf}=>$class;
my$head;
if(defined$pos){$head=substr$$text_ref,0,$pos,'';
substr($head,-(length$mycrlf))='';}else{$head=$$text_ref;
$text_ref=\'';}my$header_class=$arg->{header_class}||$self->default_header_class;
$self->header_obj_set($header_class->new(\$head,{crlf=>$self->crlf}));
$self->body_set($text_ref);
return$self;}sub _split_head_from_body{my($self,$text_ref)=@_;
my$crlf=$self->__crlf_re;
if($$text_ref=~/(?:.*?($crlf))\1/gsm){return(pos($$text_ref),$1);}else{return(undef,"\n");}}our$CREATOR='Email::Simple::Creator';
sub create{my($class,%args)=@_;
my$headers=$args{header}||[Date=>$CREATOR->_date_header];
my$body=$args{body}||'';
my$empty=q{};
my$header=\$empty;
for my $idx(map{$_*2}0..@$headers/2-1){my($key,$value)=@$headers[$idx,$idx+1];
$CREATOR->_add_to_header($header,$key,$value);}$CREATOR->_finalize_header($header);
my$email=$class->new($header);
$email->header_set(Date=>$CREATOR->_date_header)unless defined$email->header('Date');
$body=(join$CREATOR->_crlf,split/\x0d\x0a|\x0a\x0d|\x0a|\x0d/,$body).$CREATOR->_crlf;
$email->body_set($body);
return$email;}sub header_obj{my($self)=@_;
return$self->{header};}BEGIN{*__head=\&header_obj}sub header_obj_set{my($self,$obj)=@_;
$self->{header}=$obj;}BEGIN{no strict 'refs';
for my $method(qw(header header_set header_names header_pairs)){*$method=sub{(shift)->header_obj->$method(@_)};}*headers=\&header_names;}sub body{my($self)=@_;
return(defined${$self->{body}})?${$self->{body}}:'';}sub body_set{my($self,$text)=@_;
my$text_ref=ref$text?$text:\$text;
$self->{body}=$text_ref;
return;}sub as_string{my$self=shift;
return$self->header_obj->as_string.$self->crlf.$self->body;}sub crlf{$_[0]->{mycrlf}}sub default_header_class{'Email::Simple::Header'}1;
__END__

