DirectMail.mf = DirectMail.mf || {};
var de = function (n, ord) {
  var s = String(n).split('.'), v0 = !s[1];
  if (ord) return 'other';
  return (n == 1 && v0) ? 'one' : 'other';
};
var plural = function (value, offset, lcfunc, data, isOrdinal) {
  if ({}.hasOwnProperty.call(data, value)) return data[value];
  if (offset) value -= offset;
  var key = lcfunc(value, isOrdinal);
  if (key in data) return data[key];
  return data.other;
};
var fmt = {
  number: function (value, lc, arg
  /*``*/) {
  
    var a = arg && arg.split(':') || []
    var opt = {
      integer: { maximumFractionDigits: 0 },
      percent: { style: 'percent' },
      currency: {
        style: 'currency',
        currency: a[1] && a[1].trim() || "USD",
        minimumFractionDigits: 2,
        maximumFractionDigits: 2
      }
    }
    return new Intl.NumberFormat(lc, opt[a[0]] || {}).format(value)
  
  }
};

DirectMail.mf.HistorySummary = {
  SCHEDULE_DELIVERY: function(d) { return "Lieferung planen"; },
  RESCHEDULE_DELIVERY: function(d) { return "Lieferung neu planen"; },
  CANCELLING: function(d) { return "Abbrechen …"; },
  CANCEL_DELIVERY: function(d) { return "Lieferung abbrechen"; },
  UPDATE_ERROR_DETAILS: function(d) { return "Beim Aktualisieren dieses Berichts ist ein Fehler aufgetreten: " + d.error_description; },
  UPDATE_ERROR: function(d) { return "Beim Aktualisieren dieses Berichts ist ein Fehler aufgetreten."; },
  POPOVER_BOUNCES: function(d) { return d.value + " gebounct (" + d.ratio + " aller Empfänger)"; },
  POPOVER_SPAM: function(d) { return d.value + " als Spam markiert (" + d.ratio + " aller zugestellten E-Mails)"; },
  POPOVER_UNSUBSCRIBES: function(d) { return d.value + " Abmeldungen (bei " + d.ratio + " aller zugestellten E-Mails)"; },
  TOOLTIP_NUM_CLICKED_LINK: function(d) { return plural(d.num_clicked, 0, de, { one: "1 Empfänger hat diesen Link geklickt", other: fmt.number(d.num_clicked, "de", "integer") + " Empfänger haben diesen Link geklickt" }); },
  POPOVER_OPENS: function(d) { return d.number_opened + " geöffnet (" + d.open_rate + " aller zugestellten E-Mails, " + plural(d.number_of_views, 0, de, { one: "1 Öffnung gesamt", other: fmt.number(d.number_of_views, "de", "integer") + " Öffnungen gesamt" }) + ")"; },
  POPOVER_CLICKS: function(d) { return d.number_clicked + " angeklickt (" + d.click_rate + " aller zugestellten E-Mails, " + plural(d.number_of_clicks, 0, de, { one: "1 Klick gesamt", other: fmt.number(d.number_of_clicks, "de", "integer") + " Klicks gesamt" }) + ")"; }
}
;
if ( fmt !== undefined ) {
    if ( window.DirectMail_nativeController !== undefined && window.DirectMail_nativeController.formatNumber !== undefined ) {
        fmt.number = function(v,lc,p) {
            return window.DirectMail_nativeController.formatNumber(v,p);
        };
    }
    else {
        var fmt_number = fmt.number;
        fmt.number = function(v,lc,p) {
            return fmt_number(v,navigator.language,p);
        };
    }
}
